import html from './template.html'

export default {
  template: html,
  model: {
    prop: 'checked',
    event: 'change'
  },
  props: {
    checked: {
      type: Boolean,
      default: false
    },
    label: {
      type: String,
      default: ''
    },
    disabled: {
      type: Boolean,
      default: false
    },
    needCbToggle: {
      type: Boolean,
      default: false
    }
  },

  data() {
    return {}
  },

  methods: {
    $toggleCheck(event) {
      if (this.disabled !== true) {
        if (this.needCbToggle !== true) {
          this.checked = !this.checked
          this.$emit('change', this.checked)
          event.stopPropagation()
        } else {
          // not allow to cancel current selected
          if (!this.checked) {
            this.$emit('change', !this.checked)
            event.stopPropagation()
          }
        }
      }
    }
  },

  created() {},
  mounted() {}
}
