import html from './template.html'
// import models from './models'
const envCfg = require('env.cfg')

export default {
  template: html,
  data() {
    return {
      userName: null,
      password: '',
      validateCode: '',
      isShowScrollMask: false,
      maskImg: envCfg.publicPath + 'assets/images/scroll-mask.png'
    }
  },

  props: {
    isPopShow: {
      type: Boolean,
      required: true,
      default: false
    },
    isNeedFoot: {
      type: Boolean,
      required: true,
      default: true
    },
    closeCb: {
      type: Function
    },
    confirmCb: {
      type: Function
    },
    bodyUniqueId: {
      type: String,
      default: ''
    },
    needHandleScroll: {
      type: Boolean,
      default: false
    },
    isShowBtn: {
      type: Boolean,
      default: true
    }
  },

  components: {},

  methods: {
    $closePop() {
      if (this.needHandleScroll && this.bodyUniqueId !== '') {
        document.querySelector('#' + this.bodyUniqueId).parentElement.scrollTop = 0
      }
      if (this.closeCb && typeof this.closeCb === 'function') {
        this.closeCb()
      } else {
        this.isPopShow = false
      }
    },
    $handleScroll() {
      let selector

      if (this.needHandleScroll !== true) {
        return false
      }

      if (this.bodyUniqueId !== '') {
        selector = document.querySelector('#' + this.bodyUniqueId).parentElement
      } else {
        return
      }
      let bodyShowHeight = selector.clientHeight
      let bodyActualHeight = selector.scrollHeight
      let scrollTop = selector.scrollTop
      this.isShowScrollMask = (scrollTop + bodyShowHeight) < bodyActualHeight
    },
    $maskOnTouchStart(event) {
      event.preventDefault()
      event.stopPropagation()
    }
  // scrollHandler() {
  //   let selector
  //   if (this.bodyUniqueId !== '') {
  //     selector = document.querySelector('#' + this.bodyUniqueId).parentElement
  //   } else {
  //     return
  //   }
  //   let bodyShowHeight = selector.clientHeight
  //   let bodyActualHeight = selector.scrollHeight
  //   let scrollTop = selector.scrollTop
  //   this.isShowScrollMask = (scrollTop + bodyShowHeight) < bodyActualHeight
  // },
  // $handleScroll() {
  //   this.throttle(this.scrollHandler)
  // },
  // throttle(method, context) {
  //   clearTimeout(method.tId)
  //   method.tId = setTimeout(function () {
  //     method.call(context)
  //   }, 50)
  // }
  }
}
