import html from './template.html'
import CheckBox from 'components/checkAddress'

export default {
  template: html,
  props: {
    item: {
      type: Object,
      default: {}
    }
  },
  components: {
    'check-box': CheckBox
  },
  data() {
    return {
      isDefaultAddress: true
    }
  },

  methods: {
    $chooseAddress(event) {
      this.$emit('chooseAddress', this.item)
      event.stopPropagation()
    },
    $deleteAddress(event) {
      this.$emit('deleteAddress', this.item)
      event.stopPropagation()
    },

    $editAddress(event) {
      this.$emit('editAddress', this.item)
      event.stopPropagation()
    },

    $toggleDefault(isSetToDefault) {
      if (isSetToDefault === true) {
        this.$emit('toggleSetDefault', this.item)
      }
    }
  },

  watch: {
    'isDefaultAddress'(newVal) {
      this.$toggleDefault(newVal)
    }
  },
  created() {
    this.isDefaultAddress = (this.item.defaultFlag === 1)
  },
  mounted() {}
}
