import html from './template.html'

export default {
  template: html,
  props: {
    item: {
      type: Object,
      default: {}
    },
    needTouch: {
      type: Boolean,
      default: false
    },
    handleTouchStart: {
      type: Function
    }
  },

  data() {
    return {
      // isShowDeletedBtn: false,
      pos: {
        lastX: 0,
        lastY: 0,
        currentX: 0,
        currentY: 0
      }
    }
  },

  methods: {
    $chooseItem(event) {
      this.$emit('select', this.item)
      event.stopPropagation()
    },

    $handleDeleteBtn(event) {
      this.$el.classList.remove('show-delete-btn')
      // this.isShowDeletedBtn = false
      this.$emit('delete', this.item)
      event.stopPropagation()
    },

    $handelTochStart(event) {
      let touch = event.touches[0]
      this.pos.lastX = touch.pageX
      this.pos.lastY = touch.pageY
      event.stopPropagation()
    },

    $handelTochMove(event) {
      if (this.handleTouchStart && typeof this.handleTouchStart === 'function') {
        this.handleTouchStart()
      }
      event.stopPropagation()
    },

    $handelTochEnd(event) {
      let touch = event.changedTouches[0]
      let number = 50
      this.pos.currentX = touch.pageX
      this.pos.currentY = touch.pageY

      if (this.pos.currentX - this.pos.lastX < -number) {
        this.$el.classList.add('show-delete-btn')
      // this.isShowDeletedBtn = true
      }

      if (this.pos.currentX - this.pos.lastX > number) {
        // this.isShowDeletedBtn = false
        this.$el.classList.remove('show-delete-btn')
      }

      event.stopPropagation()
    }
  },

  mounted() {
    // this.$el.addEventListener('touchstart', this.$handelTochStart.bind(this))
    // // this.$el.addEventListener('touchstart', this.$handelTochMove.bind(this))
    // this.$el.addEventListener('touchend', this.$handelTochEnd.bind(this))
    this.$el.ontouchstart = this.$handelTochStart
    this.$el.ontouchend = this.$handelTochEnd
    this.$el.ontouchmove = this.$handelTochMove
    this.$el.onclick = this.$chooseItem
  },

  destroyed() {
    this.$el.ontouchstart = null
    this.$el.ontouchend = null
    this.$el.ontouchmove = null
    this.$el.onclick = null
  }
}
