/* global moment */
import html from './template.html'
import storage from 'common/storage'

export default {
  template: html,
  props: {
    item: {
      type: Object,
      default: {}
    },
    orderStatus: {
      type: Array,
      default: []
    }
  },

  data() {
    return {
    }
  },

  methods: {
    $expressDetail(event) {
      event.stopPropagation()
      this.$router.push({ path: '/trans/' + this.item.expressId })
    },
    $gotoOrderDetail() {
      storage.set('orderDetailInfo', this.item)
      this.$router.push({ path: '/orderDetail' })
    }
  },

  mounted() {},
  computed: {
    decorateTime() {
      return moment(this.item.orderTime).format('YYYY/MM/DD HH:mm')
    }
  }
}
