import html from './template.html'
import auth from 'common/auth'
import { SET_CURRENT_MODULE, NEED_SHOW_LOGIN_POP, SET_LOGIN_METHOD } from 'store/mutation-types'
import eventQueue from 'common/event-queue'

export default {
  template: html,
  data() {
    return {
      selectedIndex: 0,
      isPopLoginShow: false,
      currentModule: 'Home'
    }
  },
  methods: {
    $changeNav(path, moduleName) {
      if (moduleName === 'MyAll' && auth.checkUserLogin() !== true) {
        eventQueue.pushEvent({
          key: 'event-myall',
          event: this.$gotoMyAllPage,
          params: [path, moduleName],
          context: this,
          needKeep: false,
          triggerUrl: ''
        })
        this.$store.commit(SET_LOGIN_METHOD, 1)
        this.$store.commit(NEED_SHOW_LOGIN_POP, true)
      } else {
        this.$gotoNormalPage(path, moduleName)
      }
    },

    $gotoNormalPage(path, moduleName) {
      this.$store.commit(SET_CURRENT_MODULE, moduleName)
      this.$router.push(path)
    },

    $gotoMyAllPage(path, moduleName) {
      if (this.$store.state.currentModule === moduleName && moduleName === 'MyAll') {
        window.location.reload()
      } else {
        this.$gotoNormalPage(path, moduleName)
      }
    }
  },

  components: {},

  created() {},

  mounted() {}
}
