import html from './template.html'

export default {
  template: html,
  props: {
    doSearch: {
      type: Function,
      default: null
    },
    doReset: {
      type: Function,
      default: null
    },
    searchKeyWord: {
      type: String,
      default: ''
    }
  },

  data() {
    return {
      // searchKeyWord: ''
    }
  },

  methods: {
    $handelInput(e) {
      let value = e.currentTarget.value
      this.searchKeyWord = value
      if (value === '') {
        this.$resetSearch()
      }
    // this.$emit('input', value)
    },
    $handleSubmit() {
      // if (this.searchKeyWord === '') {
      //   return false
      // }
      this.$emit('input', this.searchKeyWord)
      if (typeof this.doSearch === 'function') {
        this.doSearch()
      }
      this.$emit('search', this.searchKeyWord)
    },
    $resetSearch() {
      if (typeof this.doReset === 'function') {
        this.doReset()
      }
      this.searchKeyWord = ''
      this.$emit('input', this.searchKeyWord)
      this.$emit('reset')
    }
  },

  mounted() {},
  computed: {
    canDelete() {
      return this.searchKeyWord !== ''
    }
  }
}
